import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class GregoryNewton extends Frame
{  public int Iter,Itermax; public double Err;
   public GregoryNewton()
   {  setSize(800,300);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   public double Comb(int N, int R)  // g񐔂̌vZ
   { double C;
     if     (R == 0 || R == N) C = 1;
     else if(R == 1)           C = (double) N;
     else                      C = Comb(N - 1, R - 1) + Comb(N - 1, R);
     return C;
   }
   public double Fact(int N)  // ǨvZ
   {  double D =1;
      for(int i = 2; i <= N; i++)   D *= (double) i;
      return D;
   }
   public double Deffer(int i, double[] FY)  // vZ
   { double A = 0; double Sign = 1;
     for(int k = i; k>=2; k--)
     { double C = Comb(i - 1, k - 1);
       A  +=  C * Sign * FY[k-1]; Sign = -Sign;
     }
     return (A + Sign * FY[0]);
   }
   public double Inter(int i, double UX) // ԌvZ
   { double U = UX; double T = 1;
     for(int k = 2; k <= i; k++) { T *= U; U--;}
     return T;
   }
   public double Gregory(double[] FY, double UX, int N)
   { double T = 0;
     for(int i = 1; i <= N; i++)
     {  double A = FY[0]; 
        if(i >= 2) A = Deffer(i, FY) * Inter(i, UX) / Fact(i-1);
        T += A;
     }
     return T;
   }
   public void paint(Graphics g)
   {
     double [] X  = {0,      10,      20,      30,      40};
     double [] FY = {0, 0.17365, 0.34202, 0.50000, 0.64279};
     double    DX = 10;                         // f[^Ԋu 
     double    UX = (22 - X[0]) / DX;           // 22x̒l߂
     double     R = Gregory(FY, UX, 5);
     setTitle("Gregory-Newton̕Ԏ");
     g.drawString( "ߎl R = " + R, 20, 50);
   } 
   public static void main(String[] args)
   {  Frame w = new GregoryNewton();
      w.setVisible(true);
   }
}
